/* -*- Mode: C -*-
 * This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995,
 * 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
 * 2007, 2008, 2009, 2010  Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
/* 
 * Tree evaluation in first-order logic 
 */

define eval_test(t) = {
    empty and
    format("Tree=%t\n", eval_tree([t]))
}.

define eval_tree(TreeHist) = {
    if is_integer(TreeHist[0])
    then TreeHist
    else eval_tree([eval_args(TreeHist[0])] + TreeHist)
}.

define eval_subtree(Tree) = {
    if is_integer(Tree)
    then Tree
    else eval_args(Tree)
}.

define eval_args(Tree) = {
    if is_integer(Tree[lt]) and is_integer(Tree[rt])
    then expr_val(Tree)
    else [Tree[op],eval_subtree(Tree[lt]),eval_subtree(Tree[rt])]
}.

define expr_val(Tree) = {
    if Tree[op]="+" then Tree[lt]+Tree[rt]
    else if Tree[op]="*" then Tree[lt]*Tree[rt]
}.

define op=0.
define lt=1.
define rt=2.

define eval_test1 = 1.

define eval_test2 = ["+",1,2].

define eval_test3 = ["*",["+",1,["*",2,3]],["+",4,5]].

define eval_test4 = ["+",
			["*",
			    ["+",1,1],
			    ["+",1,1]],
			["*",
			    ["+",1,1],
			    ["+",1,1]]].

define eval_test5 = ["+",["*",eval_test3,eval_test3],eval_test3].

define eval_test6 = 
  ["+",["*",["+",1,2],3],["+",["*",4,5],["+",6,7]]].

load "misc".

