/* This file is part Tempura: Interval Temporal Logic interpreter.
 *  
 * Copyright (C) 1987, 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995,
 * 1996, 1997, 1998, 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 
 * 2007, 2008, 2009, 2010  Roger Hale, Ben Moszkowski, Antonio Cau 
 *
 * Tempura is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Tempura is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Tempura.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Changes made by  AC: Antonio Cau
 *                 BCM: Ben Moszkowski
 *
 * $Id: parser.h,v 2.16 2009/12/07 11:18:30 acau Exp $
 */

# define END 0
# define NIL 1
# define BOOL 2
# define INT 3
# define LAMBDA 4
# define STRING 5
# define FLOAT 6
# define LIST 7
# define STATE 8
# define STATIC 9
# define EMPTY 10
# define SKIP 11
# define AND 12
# define iAND 13
# define OR 14
# define NOT 15
# define IF 16
# define CALL 17
# define iCALL 18
# define EXISTS 19
# define iEXISTS 20
# define PROCESS 21
# define iPROCESS 22
# define PREFIX 23
# define iPREFIX 24
# define FORALL 25
# define THE 26
# define ALWAYS 27
# define SOMETIME 28
# define HALT 29
# define INIT 30
# define FIN 31
# define KEEP 32
# define NEXT 33
# define WNEXT 34
# define LEN 35
# define iLEN 36
# define LT 37
# define LE 38
# define EQ 39
# define GE 40
# define GT 41
# define NEQ 42
# define GETS 43
# define STB 44
# define WHERE 45
# define IS 46
# define ASSN 47
# define UASSN 48
# define SEMI 49
# define iSEMI 50
# define WHILE 51
# define REPEAT 52
# define FOR 53
# define iFOR 54
# define FORTIMES 55
# define iFORTIMES 56
# define FORIN 57
# define iFORIN 58
# define PROJ 59
# define iPROJ 60
# define INPUT 61
# define OUTPUT 62
# define PLUS 63
# define MINUS 64
# define MULT 65
# define DIV 66
# define MOD 67
# define POWER 68
# define UPLUS 69
# define UMINUS 70
# define MAKELIST 71
# define TYPE 72
# define STRUCT 73
# define SIZE 74
# define SUB 75
# define SUBLIST 76
# define FIXLIST 77
# define VARLIST 78
# define REFER 79
# define DEREF 80
# define LOC 81
# define RUN 82
# define EXIT 83
# define LOAD 84
# define DEFINE 85
# define SET 86
# define SHOWTRACE 87
# define SHOWMEM 88
# define ABORT 89
# define BREAK 90
# define RETURN 91
# define CONTINUE 92
# define LEAP 93
# define STEP 94
# define PEEK 95
# define FORMAT 96
# define ASCII 97
# define HELP 98
# define SYSTEM 99
# define iSYSTEM 100
# define PASSLIMIT 101
# define VERBOSITY 102
# define PRINTLEVEL 103
# define DEBUGLEVEL 104
# define STATEPRINT 105
# define REDUNDANCY 106
# define CALLBYNAME 107
# define ASSIGNAHEAD 108
# define PATH 109
# define HELPDIR 110
# define TIMESTEP 111
# define RANDOM 112
# define RANDSEED 113
# define RRANDOM 114
# define RRANDSEED 115
# define MAXRANDLEN 116
# define IMPLIES 117
# define MORE 118
# define CHOPSTAR 119
# define iIF 120
# define iUNDEFINED 121
# define SHOWSTATE 122
# define INFILE 123
# define OUTFILE 124
# define RANLEN 125
# define INFINITE 126
# define HOPCHOP 127
# define PRECISION 128
# define CEIL 129
# define FLOOR 130
# define SQRT 131
# define ITOF 132
# define EXPO 133
# define LOG 134
# define LOGTEN 135
# define SIN 136
# define COS 137
# define TAN 138
# define ASIN 139
# define ACOS 140
# define ATAN 141
# define ATANTWO 142
# define SINH 143
# define COSH 144
# define TANH 145
# define FABS 146
# define SRANDOM 147
# define SRANDSEED 148
# define SRRANDOM 149
# define SRRANDSEED 150
# define iOR 151
# define DEFAULTS 152
# define MEM 153
# define PREV 154
# define NPREV 155

# define COMMA 156

# define TRUE 157
# define FALSE 158
# define NAME 159
# define THEN 160
# define ELSE 161
# define IN 162
# define TIMES 163
# define ENV 164
# define BND 165
# define TO 166
# define DO 167
# define LPAREN 168
# define RPAREN 169
# define LBRACE 170
# define RBRACE 171
# define LBRACK 172
# define RBRACK 173
# define BAR 174
# define UNTIL 175
# define HISTORY 176
# define MEMBLOCK 177


#define MAXREDUCETOKEN COMMA
#define MAXTOKEN MEMBLOCK

#define MQS MAXTOKEN+1
#define STL MQS+1
#define N1 STL+1
#define IDN N1+1
#define MDF IDN+1
#define EIF MDF+1
#define FTL EIF+1
#define H1 FTL+1
